From d6bda1278c1822334aacf45cdf1f2b48462da2ce Mon Sep 17 00:00:00 2001
From: Niklas Haas <git@haasn.dev>
Date: Wed, 13 Aug 2025 15:43:35 +0200
Subject: [PATCH 33/37] avfilter: use ff_draw_init_from_link() where possible

---
 libavfilter/qrencode.c       | 8 +++-----
 libavfilter/src_avsynctest.c | 2 +-
 libavfilter/vf_datascope.c   | 2 +-
 libavfilter/vf_drawtext.c    | 2 +-
 libavfilter/vf_pad.c         | 2 +-
 libavfilter/vf_rotate.c      | 2 +-
 libavfilter/vf_shear.c       | 2 +-
 libavfilter/vf_stack.c       | 2 +-
 libavfilter/vf_tile.c        | 2 +-
 libavfilter/vf_tinterlace.c  | 2 +-
 libavfilter/vf_tpad.c        | 2 +-
 libavfilter/vsrc_testsrc.c   | 9 +++------
 12 files changed, 16 insertions(+), 21 deletions(-)

diff --git a/libavfilter/qrencode.c b/libavfilter/qrencode.c
index 8c09b605ad..29fa5d3785 100644
--- a/libavfilter/qrencode.c
+++ b/libavfilter/qrencode.c
@@ -645,7 +645,7 @@ static int qrencodesrc_config_props(AVFilterLink *outlink)
     ff_draw_color(&qr->draw, &qr->draw_foreground_color, (const uint8_t *)&qr->foreground_color);
     ff_draw_color(&qr->draw, &qr->draw_background_color, (const uint8_t *)&qr->background_color);
 
-    ret = ff_draw_init2(&qr->draw0, outlink->format, outlink->colorspace, outlink->color_range, FF_DRAW_PROCESS_ALPHA);
+    ret = ff_draw_init_from_link(&qr->draw0, outlink, FF_DRAW_PROCESS_ALPHA);
     if (ret < 0) {
         av_log(ctx, AV_LOG_ERROR, "Failed to initialize FFDrawContext\n");
         return ret;
@@ -743,8 +743,7 @@ static int qrencode_config_input(AVFilterLink *inlink)
 
     qr->is_source = 0;
 
-    ret = ff_draw_init2(&qr->draw, inlink->format, inlink->colorspace, inlink->color_range,
-                        FF_DRAW_PROCESS_ALPHA);
+    ret = ff_draw_init_from_link(&qr->draw, inlink, FF_DRAW_PROCESS_ALPHA);
     if (ret < 0) {
         av_log(ctx, AV_LOG_ERROR, "Failed to initialize FFDrawContext\n");
         return ret;
@@ -777,8 +776,7 @@ static int qrencode_config_input(AVFilterLink *inlink)
     PARSE_EXPR(rendered_qrcode_width);
     PARSE_EXPR(rendered_padded_qrcode_width);
 
-    ret = ff_draw_init2(&qr->draw, inlink->format, inlink->colorspace, inlink->color_range,
-                  FF_DRAW_PROCESS_ALPHA);
+    ret = ff_draw_init_from_link(&qr->draw, inlink,  FF_DRAW_PROCESS_ALPHA);
     if (ret < 0) {
         av_log(ctx, AV_LOG_ERROR, "Failed to initialize FFDrawContext\n");
         return ret;
diff --git a/libavfilter/src_avsynctest.c b/libavfilter/src_avsynctest.c
index 9c71a9fee8..e2c66fd6be 100644
--- a/libavfilter/src_avsynctest.c
+++ b/libavfilter/src_avsynctest.c
@@ -161,7 +161,7 @@ static av_cold int config_props(AVFilterLink *outlink)
     s->dir = 1;
     s->prev_intpart = INT64_MIN;
 
-    ret = ff_draw_init2(&s->draw, outlink->format, outlink->colorspace, outlink->color_range, 0);
+    ret = ff_draw_init_from_link(&s->draw, outlink, 0);
     if (ret < 0) {
         av_log(ctx, AV_LOG_ERROR, "Failed to initialize FFDrawContext\n");
         return ret;
diff --git a/libavfilter/vf_datascope.c b/libavfilter/vf_datascope.c
index 87137cee83..3b37fd162e 100644
--- a/libavfilter/vf_datascope.c
+++ b/libavfilter/vf_datascope.c
@@ -390,7 +390,7 @@ static int config_input(AVFilterLink *inlink)
     int ret;
 
     s->nb_planes = av_pix_fmt_count_planes(inlink->format);
-    ret = ff_draw_init2(&s->draw, inlink->format, inlink->colorspace, inlink->color_range, 0);
+    ret = ff_draw_init_from_link(&s->draw, inlink, 0);
     if (ret < 0) {
         av_log(ctx, AV_LOG_ERROR, "Failed to initialize FFDrawContext\n");
         return ret;
diff --git a/libavfilter/vf_drawtext.c b/libavfilter/vf_drawtext.c
index c2f6f52f43..867536aa61 100644
--- a/libavfilter/vf_drawtext.c
+++ b/libavfilter/vf_drawtext.c
@@ -1144,7 +1144,7 @@ static int config_input(AVFilterLink *inlink)
     char *expr;
     int ret;
 
-    ret = ff_draw_init2(&s->dc, inlink->format, inlink->colorspace, inlink->color_range, FF_DRAW_PROCESS_ALPHA);
+    ret = ff_draw_init_from_link(&s->dc, inlink, FF_DRAW_PROCESS_ALPHA);
     if (ret < 0) {
         av_log(ctx, AV_LOG_ERROR, "Failed to initialize FFDrawContext\n");
         return ret;
diff --git a/libavfilter/vf_pad.c b/libavfilter/vf_pad.c
index 0c7a1d2b44..8348043e1a 100644
--- a/libavfilter/vf_pad.c
+++ b/libavfilter/vf_pad.c
@@ -114,7 +114,7 @@ static int config_input(AVFilterLink *inlink)
     double var_values[VARS_NB], res;
     char *expr;
 
-    ret = ff_draw_init2(&s->draw, inlink->format, inlink->colorspace, inlink->color_range, 0);
+    ret = ff_draw_init_from_link(&s->draw, inlink, 0);
     if (ret < 0) {
         av_log(ctx, AV_LOG_ERROR, "Failed to initialize FFDrawContext\n");
         return ret;
diff --git a/libavfilter/vf_rotate.c b/libavfilter/vf_rotate.c
index 3dc57bbb08..740acfe3bd 100644
--- a/libavfilter/vf_rotate.c
+++ b/libavfilter/vf_rotate.c
@@ -288,7 +288,7 @@ static int config_props(AVFilterLink *outlink)
     double res;
     char *expr;
 
-    ret = ff_draw_init2(&rot->draw, inlink->format, inlink->colorspace, inlink->color_range, 0);
+    ret = ff_draw_init_from_link(&rot->draw, inlink, 0);
     if (ret < 0)
         return ret;
     ff_draw_color(&rot->draw, &rot->color, rot->fillcolor);
diff --git a/libavfilter/vf_shear.c b/libavfilter/vf_shear.c
index 2e558c0044..11edd1063d 100644
--- a/libavfilter/vf_shear.c
+++ b/libavfilter/vf_shear.c
@@ -261,7 +261,7 @@ static int config_output(AVFilterLink *outlink)
     s->planeheight[1] = s->planeheight[2] = AV_CEIL_RSHIFT(ctx->inputs[0]->h, desc->log2_chroma_h);
     s->planeheight[0] = s->planeheight[3] = ctx->inputs[0]->h;
 
-    ret = ff_draw_init2(&s->draw, outlink->format, outlink->colorspace, outlink->color_range, 0);
+    ret = ff_draw_init_from_link(&s->draw, outlink, 0);
     if (ret < 0) {
         av_log(ctx, AV_LOG_ERROR, "Failed to initialize FFDrawContext\n");
         return ret;
diff --git a/libavfilter/vf_stack.c b/libavfilter/vf_stack.c
index fa202ee0cc..a36e1bab64 100644
--- a/libavfilter/vf_stack.c
+++ b/libavfilter/vf_stack.c
@@ -312,7 +312,7 @@ static int config_output(AVFilterLink *outlink)
 
         if (s->fillcolor_enable) {
             const AVFilterLink *inlink = ctx->inputs[0];
-            ret = ff_draw_init2(&s->draw, inlink->format, inlink->colorspace, inlink->color_range, 0);
+            ret = ff_draw_init_from_link(&s->draw, inlink, 0);
             if (ret < 0) {
                 av_log(ctx, AV_LOG_ERROR, "Failed to initialize FFDrawContext\n");
                 return ret;
diff --git a/libavfilter/vf_tile.c b/libavfilter/vf_tile.c
index 7f2f212c4a..8c87b44af8 100644
--- a/libavfilter/vf_tile.c
+++ b/libavfilter/vf_tile.c
@@ -144,7 +144,7 @@ static int config_props(AVFilterLink *outlink)
     outlink->h = tile->h * inlink->h + total_margin_h;
     outlink->sample_aspect_ratio = inlink->sample_aspect_ratio;
     ol->frame_rate = av_mul_q(il->frame_rate, av_make_q(1, tile->nb_frames - tile->overlap));
-    ret = ff_draw_init2(&tile->draw, inlink->format, inlink->colorspace, inlink->color_range, 0);
+    ret = ff_draw_init_from_link(&tile->draw, inlink, 0);
     if (ret < 0) {
         av_log(ctx, AV_LOG_ERROR, "Failed to initialize FFDrawContext\n");
         return ret;
diff --git a/libavfilter/vf_tinterlace.c b/libavfilter/vf_tinterlace.c
index ad02ba4405..7d5217c364 100644
--- a/libavfilter/vf_tinterlace.c
+++ b/libavfilter/vf_tinterlace.c
@@ -228,7 +228,7 @@ static int config_out_props(AVFilterLink *outlink)
 
     if (tinterlace->mode == MODE_PAD) {
         uint8_t black[4] = { 0, 0, 0, 16 };
-        ret = ff_draw_init2(&tinterlace->draw, outlink->format, outlink->colorspace, outlink->color_range, 0);
+        ret = ff_draw_init_from_link(&tinterlace->draw, outlink, 0);
         if (ret < 0) {
             av_log(ctx, AV_LOG_ERROR, "Failed to initialize FFDrawContext\n");
             return ret;
diff --git a/libavfilter/vf_tpad.c b/libavfilter/vf_tpad.c
index f498bf4a3e..7580fbaa5b 100644
--- a/libavfilter/vf_tpad.c
+++ b/libavfilter/vf_tpad.c
@@ -209,7 +209,7 @@ static int config_input(AVFilterLink *inlink)
     int ret;
 
     if (needs_drawing(s)) {
-        ret = ff_draw_init2(&s->draw, inlink->format, inlink->colorspace, inlink->color_range, 0);
+        ret = ff_draw_init_from_link(&s->draw, inlink, 0);
         if (ret < 0) {
             av_log(ctx, AV_LOG_ERROR, "Failed to initialize FFDrawContext\n");
             return ret;
diff --git a/libavfilter/vsrc_testsrc.c b/libavfilter/vsrc_testsrc.c
index 81301edbfe..23ecb5bdb2 100644
--- a/libavfilter/vsrc_testsrc.c
+++ b/libavfilter/vsrc_testsrc.c
@@ -257,8 +257,7 @@ static int color_config_props(AVFilterLink *inlink)
     TestSourceContext *test = ctx->priv;
     int ret;
 
-    ret = ff_draw_init2(&test->draw, inlink->format, inlink->colorspace,
-                        inlink->color_range, 0);
+    ret = ff_draw_init_from_link(&test->draw, inlink, 0);
     if (ret < 0) {
         av_log(ctx, AV_LOG_ERROR, "Failed to initialize FFDrawContext\n");
         return ret;
@@ -941,8 +940,7 @@ static int test2_config_props(AVFilterLink *inlink)
     AVFilterContext *ctx = inlink->src;
     TestSourceContext *s = ctx->priv;
 
-    av_assert0(ff_draw_init2(&s->draw, inlink->format, inlink->colorspace,
-                             inlink->color_range, 0) >= 0);
+    av_assert0(ff_draw_init_from_link(&s->draw, inlink, 0) >= 0);
     s->w = ff_draw_round_to_sub(&s->draw, 0, -1, s->w);
     s->h = ff_draw_round_to_sub(&s->draw, 1, -1, s->h);
     if (av_image_check_size(s->w, s->h, 0, ctx) < 0)
@@ -2022,8 +2020,7 @@ static int colorchart_config_props(AVFilterLink *inlink)
     AVFilterContext *ctx = inlink->src;
     TestSourceContext *s = ctx->priv;
 
-    av_assert0(ff_draw_init2(&s->draw, inlink->format, inlink->colorspace,
-                             inlink->color_range, 0) >= 0);
+    av_assert0(ff_draw_init_from_link(&s->draw, inlink, 0) >= 0);
     if (av_image_check_size(s->w, s->h, 0, ctx) < 0)
         return AVERROR(EINVAL);
     return config_props(inlink);
-- 
2.49.1


